package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.openqa.selenium.Keys;

public class LancamentoEntradaPages extends PageBase {

    //sem relacionamento
    By filtroAplicarFiltro = By.xpath("//span[text() = 'Aplicar filtro'][1]");
    By adicionarLancamento = By.xpath("//*[@class='zh-test-box']");
    By fieldChaveDeAcesso = By.xpath("//input[@zh-id='16725510125100681503667']");
    By salvarRelacionamento = By.xpath("//*[@data-zh-id='16725510123832824013522']//span");
    By salvarVencimento = By.xpath("//*[@data-zh-id='167255101225949958583622']//span");
    By salvarLancamento = By.xpath("//*[@data-zh-id='167255101212896987043729']//span");
    By loadingWait = By.xpath("//*[@class='zh-background-loading ng-scope']//span[@class='zh-loading-icon']");
    By qntProd = By.xpath("//span[text() = '50,0000']");
    By lote = By.xpath("//*[@zh-id='1899882902891348800955']");
    By actionRastreabilidade = By.xpath("//span[@data-zh-title-tooltip='Rastreabilidade']");
    By infoComplementaresDtValidade = By.id("DTVALILOTE");
    By btnConfirmar = By.xpath("//span[text() = 'Confirmar']");
    By btnConfirmarPopup = By.xpath("//*[@id='popup']//*[@data-zh-id='16725510121846765035965']//span");
    By btnFecharNf = By.xpath("//span[text() = 'Fechar NF']");
    By popupSim = By.xpath("//span[text() = 'Sim']");
    By popupClicarEmOK = By.xpath("//span[text() = 'OK']");
    By tabConfirmaFechamento = By.xpath("//span[text() = 'Confirmar Fechamento']");
    By btnVoltar = By.xpath("//span[text() = 'Voltar']");
    By statusAtual = By.xpath("//span[text() = 'Pendente']");
    By refreshWidgetLancEntrada = By.xpath("//section[@data-zh-id='16725510123916396093497']//span[@data-zh-touchstart='refreshWidget()']");

    //Com relacionamento
    By lineItemUm = By.xpath("//*[@id='grid-167255101231153330073498']//*[@class='tr cell1 produtoRelacionadoInvalido'][1]//div[1]");
    By lineItemDois = By.xpath("//*[@id='grid-167255101231153330073498']//*[@class='tr cell2 produtoRelacionadoInvalido'][1]//div[1]");
    By lineItemTres = By.xpath("//*[@class='tr cell1 produtoRelacionadoInvalido']//div[1]");
    By btnEditarProduto = By.xpath("//*[@data-zh-id='167255101215341896543514']//div");
    By clickSearchProdutoImportar = By.xpath("//div[@id='CDARVPRODFORNXML']//input[@type='text']");
    By selecionaProdutoImportar = By.xpath("//span[@data-item-identifier='00A103800000']");
    By selecionaProdutoImportarTres = By.xpath("//*[@data-item-identifier='07Z917901A00']");
    By actionRastreabilidadeUm = By.xpath("//div[@class='tr cell1'][1]//span[@data-zh-title-tooltip='Rastreabilidade']");
    By btnConfirmarInfoComplementar = By.xpath("//section[@id='popup']//li[@data-zh-id='1899882901076133865972']//span");
    By capturaMensagemFechamentoNf = By.xpath("//*[@class='notification-message-text']");

    //Com chave CTE sem relacionamento
    By tipoCteField = By.xpath("//div[@data-zh-id='16725510122377895402192']//div[2]");
    By selecionarTipoCte = By.xpath("//li[text()='CT-e Normal']");
    By clicarOperacaoEntradaField = By.xpath("//div[@id='NMTIPOOPER']//span[@class = 'value']");
    By procuraOperacaoEntrada = By.xpath("//*[@data-zh-id='167255101227623913393658']//*[@type='text']");
    By selecionaOperacaoEntrada = By.xpath("//span[@data-item-identifier='27']");
    By clicaConhecimentoTransporte = By.xpath("//span[text()='Conhecimento de Transporte']");

    //edicao de NF sem relacionamento
    By selecionaNotafiscal = By.xpath("//*[@class='tr cell1']//*[@data-zh-field-name='NRNOTAFISC'][1]");
    By clickVencimento = By.xpath("//*[text()='Vencimento']");
    By selecionaVencimento = By.xpath("//*[text()='Em Aberto']");
    By btnEditarvencimento = By.xpath("//*[@data-zh-id='167255101217502524033618']//div");
    By apagarVencimento = By.xpath("//*[@ng-if='fieldRow']");
    By clicarVencimento = By.xpath("//*[@id='DTATUAVENPAG']");

    //comparacao de produto NF x prod relacionamento
    By compProdUm = By.xpath("//*[@class='tr cell1 row-editing currentRow']//*[@data-zh-field-name='NMPRODUTO']//span");//Agua
    By compProdDois = By.xpath("//*[@class='tr cell2']//*[@data-zh-field-name='NMPRODUTO']//span");// Gelf
    By compProdTres = By.xpath("//*[@class='tr cell1']//*[@data-zh-field-name='NMPRODUTO']//span");//Hela
    By procuraFornecedorRelac = By.xpath("//*[@id='NMRAZSOCFORN']/input");
    By selecionaFornecedorRelacEmpresaTeste = By.xpath("//*[@data-item-identifier='J43283862000181']");
    By aplicarFiltroRelacProdForn = By.xpath("//*[@class='popup-container']//*[text() = 'Aplicar filtro']");
    By compProdXmlUm = By.xpath("//*[@class='tr cell2'][1]//*[@data-zh-field-name='NMPRODUTOXML']//span");// Agua
    By compProdXmlDois = By.xpath("//*[@class='tr cell2'][2]//*[@data-zh-field-name='NMPRODUTOXML']//span");// Gelf
    By compProdXmlTres = By.xpath("//*[@class='tr cell2'][3]//*[@data-zh-field-name='NMPRODUTOXML']//span");//Hela

    //lançamento de NF
    By procuraRemetenteNfEntrada = By.xpath("//*[@id='NMRAZSOCFORN']//input");
    By selecionaRemetenteNfEntrada = By.xpath("//*[@data-item-identifier='J61278875000144']");
    By clicaNumeroNfEntrada = By.id("NRNOTAFISC");
    By clicaSerie = By.xpath("//*[@id='CDSERIEENTR']/input");
    By selecionaSerie = By.xpath("//*[@class='col-xs-4 zh-field']//*[@data-item-index='2']");
    By clicaValor = By.xpath("//*[@zh-id='167255101212831109873688']");
    By clicarAbaProduto = By.xpath("//a[text()='Produtos']");
    By clicarFieldProduto = By.id("NMPRODUTO");
    By clicarFieldPreencherProduto = By.xpath("//*[@id='NMPRODUTO']//input");
    By selecionaProdutoGelf = By.xpath("//*[@data-item-identifier='00A103800001']");
    By clicaQuantidadeField = By.id("QTITEMPROD");
    By clicarVrUnitario = By.id("VRUNITITEM"); //
    By salvarProd = By.xpath("//*[@data-zh-id='16725510125382292663566']//span");
    By salvarProduto = By.xpath("//*[@data-zh-id='167255101214504813943568']//span");
    By voltarTelaProduto = By.xpath("//*[@class='previous zh-ripple-effect']//*[@class='zh-footer-title-sprit ng-binding']");
    By selecionaProdutoAgua = By.xpath("//*[@data-item-identifier='07Z917901A00']");
    By checkboxNotaEntrada = By.xpath("//*[@data-ng-if='!row.__group']");
    By btnAprovacao = By.xpath("//*[@data-zh-id='16725510124129845655794']");
    By confirmaAprovacao = By.xpath("//*[@data-ng-bind='button.label']");
    By statusAprovado = By.xpath("//span[text() = 'Aprovada']");
    By cancelarAprovacao = By.xpath("//*[@data-zh-id='16725510121847415955796']");

    //simples remessa
    By clicaTipoOperacao = By.id("NMTIPOOPER");
    By selecionaSimplesRemessa = By.xpath("//*[@data-item-identifier='04']");
    By clicaProduto = By.xpath("//*[@class='tr cell1']//*[@data-zh-field-name='CDPRODEMIS']//*[text()='00.A1.038.000.01']");
    By retornaCfop = By.xpath("//*[@id='span-field-CDFISOPEITEM']//p");
    By voltarTelaNf = By.xpath("//*[@data-zh-id='167255101236206225463562']//span");
    By clicarAbaCalculoImposto = By.xpath("//a[text()='Cálculo Imposto']");
    By retornaIcms = By.xpath("//*[@class='tr cell1'][1]//*[@data-zh-field-name='VRIMPOSTONF']//span");
    By retornaIpi = By.xpath("//*[@class='tr cell2'][1]//*[@data-zh-field-name='VRIMPOSTONF']//span");
    By retornaPis = By.xpath("//*[@class='tr cell1'][2]//*[@data-zh-field-name='VRIMPOSTONF']//span");
    By retornaCofins = By.xpath("//*[@class='tr cell2'][2]//*[@data-zh-field-name='VRIMPOSTONF']//span");

    //multiplos produtos
    By clicarProdutoLupa = By.xpath("//*[@id='NMPRODUTO']//span[@zh-icon='no-border search']");
    By selecionaCheckboxProdutoUm = By.xpath("//*[@class='tr cell1'][1]//*[@data-ng-if='!row.__group']");
    By selecionaCheckboxProdutoDois = By.xpath("//*[@data-ng-if='popupOpen']//*[@class='tr cell2'][1]//*[@data-ng-if='!row.__group']");
    By selecionaCheckboxProdutoTres = By.xpath("//*[@class='tr cell2'][2]//*[@data-ng-if='!row.__group']");
    By reload = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[1]/span[1]");
    By campoQuantProd = By.xpath("//*[@class='tr cell1'][1]//*[@data-zh-field-name='QTITEMPROD']//div");
    By campoVrUnitProd = By.xpath("//*[@class='tr cell1'][1]//*[@data-zh-field-name='VRUNITITEM']//div");
    By campoQuantProd2 = By.xpath("//*[@class='tr cell2'][1]//*[@data-zh-field-name='QTITEMPROD']//div");
    By campoVrUnitProd2 = By.xpath("//*[@class='tr cell2 row-editing currentRow']//*[@data-zh-field-name='VRUNITITEM']//div");
    By campoQuantProd3 = By.xpath("//*[@class='tr cell1'][2]//*[@data-zh-field-name='QTITEMPROD']//div");
    By campoEditQuantProd = By.xpath("//*[@class='tr cell1 row-editing currentRow']//*[@data-zh-field-name='QTITEMPROD']//input");
    By campoEditVrUnitProd = By.xpath("//*[@class='tr cell1 row-editing currentRow'][1]//*[@data-zh-field-name='VRUNITITEM']//input");
    By campoEditQuantProd2 = By.xpath("//*[@class='tr cell2 row-editing currentRow']//*[@data-zh-field-name='QTITEMPROD']//input");
    By campoEditVrUnitProd2 = By.xpath("//*[@class='tr cell2 row-editing currentRow']//*[@data-zh-field-name='VRUNITITEM']//input");
    By campoEditQuantProd3 = By.xpath("//*[@class='tr cell1 row-editing currentRow']//*[@data-zh-field-name='QTITEMPROD']//input");
    By campoEditVrUnitProd3 = By.xpath("//*[@class='tr cell1 row-editing currentRow']//*[@data-zh-field-name='VRUNITITEM']//input");
    By rastreabilidadeProdHela = By.xpath("//*[@class='tr cell1']//*[@class='zh-grid-actions']");
    By rastreabilidadeProdGeflu = By.xpath("//*[@class='tr cell2'][1]//*[@class='zh-grid-actions']");

    //valida produto estoque
    By selecionaProdutoEstoqueAgua = By.xpath("//*[@data-item-identifier='01A417200000']");
    By selecionaProdutoEstoqueHela = By.xpath("//*[@data-item-identifier='00A103800000']");
    By capturaMensagemProdutoEstoque = By.xpath("//*[@class='zh-text-alert']");
    By selecionaProdutoCompraPa = By.xpath("//*[@data-item-identifier='08E415002301']");
    By selecionaProdutoCompraCebola = By.xpath("//*[@data-item-identifier='01A302201102']");

    //validarLancamentoNotaEntradaProdutoControlaEstoqueNãoControlaLote
    By selecionaProdutoSucralose = By.xpath("//*[@data-item-identifier='01A503700304']");
    By retornaInfoComplementaresAlmox = By.xpath("//label[@data-zh-id='1899882901280710555943']//span");
    By retornaAlmoxSelecionado = By.xpath("//*[@id='CDALMOXARIFE']//span[1]");

    //validarLancamentoNotaEntradaFilialControlaEstoqueENaoControlaLote
    By clicaFieldAlmoxarifado = By.xpath("//*[@id='CDALMOXARIFE']");
    By selecionaAlmoxarifado = By.xpath("//*[@data-item-identifier='01']");
    By capturaTituloALmox = By.xpath("//*[@class='popup-title']");
    By selecionaProdutoHelaOx = By.xpath("//*[@data-item-identifier='00A103900000']");
    By selecionaProdutoHummer = By.xpath("//*[@data-item-identifier='00A104000001']");
    By clicaRastreabilidade1 = By.xpath("//*[@class='tr cell1']//*[@data-zh-title-tooltip='Rastreabilidade']");
    By clicaRastreabilidade2 = By.xpath("//*[@class='tr cell2']//*[@data-zh-title-tooltip='Rastreabilidade']");
    By clicaRastreabilidadeteste = By.xpath("//*[@class='tr cell2 row-editing currentRow']//*[@data-zh-title-tooltip='Rastreabilidade']");

    //validarLancamentoNotaEntradaFilialControlaEstoqueENaoControlaLoteProdNaoControlaEstoqueeNaoControlaLote
    By selecionaProdutoAguaSanitaria = By.xpath("//*[@data-item-identifier='07Z918200015']");
    By clicaFieldUnidadeFiltro = By.id("NMFILIAL");
    By selecionaFieldUnidade0003Filtro = By.xpath("//*[@data-zh-id='167255101221254548153651']//*[@data-item-index='2']");

    //validarLancamentoNotaEntradaNãoControlaAlmoxarifado
    By selecionaFieldUnidade0004Filtro = By.xpath("//*[@data-zh-id='167255101221254548153651']//*[@data-item-index='3']");
    By selecionaTpOperacSimplesRemessa = By.xpath("//*[@data-item-identifier='04']");
    By selecionaTpOperacTransferencia = By.xpath("//*[@data-item-identifier='02']");

    //mensagem Thais memoriza datas
    By popupNao = By.xpath("//span[text() = 'Não']");

    //efetuarLancamentoNotaEntradaSemChaveTransferencia
    By procuraRemetenteNfEntradaFiliEmit = By.xpath("//*[@id='DSFILIEMIT']//input");
    By selecionaRemetenteNfEntradaFiliEmit = By.xpath("//*[@data-zh-id='167255101228315523003678']//*[@data-item-index='0']");
    //efetuarLancamentoNotaEntradaSemChaveComplemento
    By selecionaTpOperacComplemento = By.xpath("//*[@data-item-identifier='03']");
    By clicarAbaDadosAdicionaisEntrada = By.xpath("//a[text()='Dados Adicionais']");
    By clicarAdicionarDadosAdicionaisEntrada = By.xpath("//*[@data-zh-id='16725510121945095733639']");
    By clicaMensagemDadosAdicionaisEntrada = By.id("DSDADOADIC");

    //validarLancamentoNotaEntradaComChaveFilialControlaEstoqueENaoControlaLoteNãoSugereAlmoxarifado
    By clicarAcoesEntrada = By.xpath("//*[@data-zh-id='zh-footer-more']//span");
    By clicarFecharNFAcoes = By.xpath("//*[@data-zh-id='167255101237658615043739']//span");
    By clicarEmCancelarEntrada = By.xpath("//*[@id='popup']//*[@data-zh-id='16725510121805780084235']//span");

    By clickUploadImportacao = By.xpath("//*[@data-zh-id='21131039032075034216461']//div");
    By escolherArquivo = By.xpath("//*[@type='file']");

    public void clickAplicarFiltro() {
        waitForInvisibilityOfElementLocated(loadingWait);
        click(filtroAplicarFiltro);
    }
    public void clicarAdicionarLancamento() {
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(adicionarLancamento);
        click(adicionarLancamento);
    }
    public void preencherChave(String chave) {
        click(fieldChaveDeAcesso);
        sendKeys(fieldChaveDeAcesso, chave + Keys.TAB);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarSalvarLancEntrada() {
        waitForInvisibilityOfElementLocated(loadingWait);
        click(salvarLancamento);
    }
    public void clicarSalvarLancRelacionamento() {
        waitForInvisibilityOfElementLocated(loadingWait);
        click(salvarRelacionamento);
    }
    public void clicarSalvarVencimento() {
        waitForInvisibilityOfElementLocated(loadingWait);
        click(salvarVencimento);
    }
    public String quantidadeProduto() {
        return getText(qntProd);
    }

    public void clicarRastreabilidade() {
        waitForInvisibilityOfElementLocated(loadingWait);
        click(actionRastreabilidade);
    }
    public String lote(){return getValue(lote);}

    public void infoComplementarProd(String dtValidade) {
        waitForInvisibilityOfElementLocated(loadingWait);
        click(infoComplementaresDtValidade);
        waitForInvisibilityOfElementLocated(loadingWait);
        sendKeys(infoComplementaresDtValidade, dtValidade);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarConfirmar() {
        waitForVisibilityOfElementLocated(btnConfirmar);
        click(btnConfirmar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarConfirmarRelac() {
        click(btnConfirmar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void fecharNF() {
        waitForInvisibilityOfElementLocated(loadingWait);
        click(btnFecharNf);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarConfirmaFechamento() {
        click(popupSim);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void popUpClicarEmOK() {
        click(popupClicarEmOK);
        waitForInvisibilityOfElementLocated(popupClicarEmOK);
    }
    public void tabMensagemFechamento() {
        waitForVisibilityOfElementLocated(tabConfirmaFechamento);
        click(tabConfirmaFechamento);
    }
    public void clicarVoltarTela() {
        waitForInvisibilityOfElementLocated(loadingWait);
        click(btnVoltar);
    }
    public void clicarRefreshScreen() {
        waitForInvisibilityOfElementLocated(loadingWait);
        waitForVisibilityOfElementLocated(refreshWidgetLancEntrada);
        click(refreshWidgetLancEntrada);
    }
    public String retornarStatusLancamento() {
        return getText(statusAtual);
    }

    // com relacionamento
    public void relacionarItemUm() {
        click(lineItemUm);
    }
    public void editarRelacionamentoProduto() {
        click(btnEditarProduto);
    }
    public void procuraProdutoImportar(String produtoImportar){
        sendKeys(clickSearchProdutoImportar, produtoImportar);
    }
    public void selecionaProdutoField() {
        click(selecionaProdutoImportar);
    }

    // relacionamento Dois
    public void relacionarItemDois() {
        click(lineItemDois);
    }
    //relacionamento Tres
    public void relacionarItemTres() {
        click(lineItemTres);
    }
    public void selecionaProdutoTresField() {
        click(selecionaProdutoImportarTres);
    }
    //rastreabilidade
    public void clicarRastreabilidadeUm() {
        waitForInvisibilityOfElementLocated(loadingWait);
        click(actionRastreabilidadeUm);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarConfirmarInfoComplementar() {
        click(btnConfirmarInfoComplementar);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public String capturaMensagemFechamento(){
        return getText(capturaMensagemFechamentoNf);
    }

    // lançamento CTE Sem relacionamento
    public void clicarTipoCte(){
        click(tipoCteField);
    }
    public void selecionarTipoCte(){
        click(selecionarTipoCte);
    }
    public void clicaOperacao(){
        click(clicarOperacaoEntradaField);
    }
    public void procuraOperacao(String operacaoCte){
        sendKeys(procuraOperacaoEntrada, operacaoCte);
    }
    public void selecionaOperacao(){
        click(selecionaOperacaoEntrada);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicaConhecimentoTransporte(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(clicaConhecimentoTransporte);
    }

    // edit NF sem relacionamento
    public void selecionaNotaFiscal(){
        click(selecionaNotafiscal);
    }
    public void clicaVencimento(){
        click(clickVencimento);
    }
    public void selecionaVencimento(){
        click(selecionaVencimento);
    }
    public void clicarEditarVencimento(){
        click(btnEditarvencimento);
    }
    public void apagarVencimento(){
        click(apagarVencimento);
    }
    public void clicarVencimento(){
        click(clicarVencimento);
    }
    public void digitarVencimento(String dataAtual){
        sendKeys(clicarVencimento, dataAtual);
    }
    public void salvarVencimento(){
        click(salvarVencimento);
    }
    public void popupRateio(){
        click(popupSim);
    }

    // compara prod NF x prod XML
    public String comparaProdUm(){
        return getText(compProdUm);
    }
    public String comparaProdDois(){
        return getText(compProdDois);
    }
    public String comparaProdTres(){
        return getText(compProdTres);
    }
    public void searchRelacProdForn(String fornecedor){
        click(procuraFornecedorRelac);
        sendKeys(procuraFornecedorRelac, fornecedor);
    }
    public void selecionaFornecedorRelac(){
        click(selecionaFornecedorRelacEmpresaTeste);
    }
    public void clicarAplicarFiltro(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(aplicarFiltroRelacProdForn);
    }
    public String comparaProdXmlUm(){
        return getText(compProdXmlUm);
    }
    public String comparaProdXmlDois(){
        return getText(compProdXmlDois);
    }
    public String comparaProdXmlTres(){
        return getText(compProdXmlTres);
    }
    //lancamento de NF
    public void clicaRemententeNfEntrada(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(procuraRemetenteNfEntrada);
    }
    public void procuraRemetenteNfEntrada(String remetente){
        sendKeys(procuraRemetenteNfEntrada, remetente);
    }
    public void selecionaRemetenteNfEntrada(){
        click(selecionaRemetenteNfEntrada);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicaNumeroField(){
        click(clicaNumeroNfEntrada);
    }
    public void informaNumero(String numero){
        sendKeys(clicaNumeroNfEntrada, numero);
    }
    public void clicaSerie(){
        click(clicaSerie);
    }
    public void selecionaSerie(){
        click(selecionaSerie);
    }
    public void preencheValor(String valor){
        click(clicaValor);
        sendKeys(clicaValor, valor + Keys.TAB);
    }
    public void salvarTeste(){
        click(salvarLancamento);
    waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarAbaProduto(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(clicarAbaProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void clicarFieldProduto(){
        click(clicarFieldProduto);
    }
    public void clicarFieldProdutoAgua(){
        click(clicarFieldPreencherProduto);
    }
    public void selecionaProdutoGelf(){
        click(selecionaProdutoGelf);
    }
    public void clicarQuantidadeField(String quantidadeProd){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(clicaQuantidadeField);
        sendKeys(clicaQuantidadeField, quantidadeProd);
    }
    public void clicarVrUnitario(){
        click(clicarVrUnitario);}
    public void informaVrUnitario(String vrUnitario){
        sendKeys(clicarVrUnitario, vrUnitario);
    }
    public void salvarProduto(){
        click(salvarProduto);
    }
    public void voltarTelaProduto(){waitForInvisibilityOfElementLocated(loadingWait);
        click(voltarTelaProduto);
        waitForInvisibilityOfElementLocated(loadingWait);
    }
    public void procuraProduto(String produto){
        sendKeys(clicarFieldPreencherProduto, produto);
    }
    public void selecionaProdutoAgua(){
        click(selecionaProdutoAgua);
    }
    public void marcarCheckBoxAprovacao(){
        click(checkboxNotaEntrada);
    }
    public void clicarAprovacao(){
        click(btnAprovacao);
    }
    public void confirmaAprovacao(){
        click(confirmaAprovacao);
    }
    public String retornaStatusAprovado(){
        return getText(statusAprovado);}
    public void cancelarAprovacao(){
        click(cancelarAprovacao);
    }

    //simples remessa
    public void clicaTpOperacao(){
        click(clicaTipoOperacao);
    }
    public void selecionaTpOperacao(){
        click(selecionaSimplesRemessa);
    }
    public void selecionaProduto(){
        click(clicaProduto);
    }
    public String retornaCfop(){
        return getText(retornaCfop);
    }
    public void voltarTelaNf(){
        click(voltarTelaNf);
    }
    public void clicarAbaCalcularImposto(){
        click(clicarAbaCalculoImposto);
    }
    public String retornaIcms(){
        return getText(retornaIcms);
    }
    public String retornaPis(){
        return getText(retornaPis);
    }
    public String retornaCofins(){
        return getText(retornaCofins);
    }
    public String retornaIpi(){
        return getText(retornaIpi);
    }

    //Multiplos Produtos
    public void clicarProdutoLupa(){
        click(clicarProdutoLupa);
    }
    public void selecionaCheckboxProdutoUm(){
        click(selecionaCheckboxProdutoUm);
    }
    public void selecionaCheckboxProdutoDois(){
        click(selecionaCheckboxProdutoDois);
    }
    public void selecionaCheckboxProdutoTres(){
        click(selecionaCheckboxProdutoTres);
    }
    public void reload(){
        click(reload);
    }
    public void scrollProduto(){
        ScrollToElementJavaScript(campoVrUnitProd);
    }
    public void campoQuantProd(String quant){
        click(campoQuantProd);
        sendKeys(campoEditQuantProd, quant + Keys.TAB);
    }
    public void campoVrUnitProd(String vrUnitario){
        sendKeys(campoEditVrUnitProd, vrUnitario+ Keys.TAB);
    }
    public void campoQuantProd2(String quant2){
        click(campoQuantProd2);
        sendKeys(campoEditQuantProd2, quant2 + Keys.TAB);
    }
    public void campoVrUnitProd2(String vrUnitario2){
        click(campoVrUnitProd2);
        sendKeys(campoEditVrUnitProd2, vrUnitario2 + Keys.ENTER);
    }
    public void campoQuantProd3(String quant3){
        click(campoQuantProd3);
        sendKeys(campoEditQuantProd3, quant3 + Keys.ENTER);
    }
    public void campoVrUnitProd3(String vrUnitario3){
        sendKeys(campoEditVrUnitProd3, vrUnitario3 + Keys.ENTER);
    }
    public void rastreabilidadeHela(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(rastreabilidadeProdHela);
    }
    public void rastreabilidadeGeflu(){
        click(rastreabilidadeProdGeflu);
    }
    public void salvarProd(){
        click(salvarProd);
    }
    // produto estoque
    public void selecionaProdutoEstoqueAgua(){
        click(selecionaProdutoEstoqueAgua);
    }
    public String capturaMensagemProdEstoque(){
        return getText(capturaMensagemProdutoEstoque);
    }
    public void selecionaProdutoEstoqueHela(){
        click(selecionaProdutoEstoqueHela);
    }
    public void selecionaProdutoCompraPa(){
        click(selecionaProdutoCompraPa);
    }
    public void selecionaProdutoCompraCebola(){
        click(selecionaProdutoCompraCebola);
    }

    // validarLancamentoNotaEntradaProdutoControlaEstoqueNãoControlaLote
    public void selecionaProdutoSucralose(){
        click(selecionaProdutoSucralose);
    }
    public String retornaInfoComplementarAlmox(){ return getText(retornaInfoComplementaresAlmox);}
    public String retornaAlmoxSelecionado(){ return getText(retornaAlmoxSelecionado);}

    // validarLancamentoNotaEntradaFilialControlaEstoqueENaoControlaLote
    public void clicaFieldAlmox(){
        click(clicaFieldAlmoxarifado);
    }
    public void selecionaAlmox(){
        click(selecionaAlmoxarifado);
    }
    public void selecionaProdutoHelaOx(){
     click(selecionaProdutoHelaOx);
    }
    public void selecionaProdutoHummer(){
        click(selecionaProdutoHummer);
    }
    public void btnConfirmarPopup(){
        click(btnConfirmarPopup);
    }
    public String retornaTituloALmox(){
        return getText(capturaTituloALmox);
    }
    public void clicaRastreabilidade1(){
        click(clicaRastreabilidade1);
    }
    public void clicaRastreabilidade2(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(clicaRastreabilidade2);
    }
    public void clicaRastreabilidadeteste(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(clicaRastreabilidade2);
    }
    //validarLancamentoNotaEntradaFilialControlaEstoqueENaoControlaLoteProdNaoControlaEstoqueeNaoControlaLote
    public void clicaFieldUnidadeFiltro(){ waitForInvisibilityOfElementLocated(loadingWait);
        click(clicaFieldUnidadeFiltro);}
    public void selecionaUnidade0003Filtro(){click(selecionaFieldUnidade0003Filtro);}
    public void selecionaProdutoAguaSanitaria(){click(selecionaProdutoAguaSanitaria);}

    //validarLancamentoNotaEntradaNãoControlaAlmoxarifado
    public void selecionaUnidade0004Filtro(){click(selecionaFieldUnidade0004Filtro);}

    //efetuarLancamentoNotaEntradaSemChaveSimplesRemessa
    public void selecionaOperacaoSimplesRemessa(String operacao){
        click(selecionaTpOperacSimplesRemessa);
    }
    //efetuarLancamentoNotaEntradaSemChaveTransferencia
    public void selecionaOperacaoTransferencia(){
        click(selecionaTpOperacTransferencia);
    }
    public void popupNao(){waitForInvisibilityOfElementLocated(loadingWait);
        click(popupNao);}

     //efetuarLancamentoNotaEntradaSemChaveTransferencia
    public void procuraRemetenteNfEntradaFiliEmit(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(procuraRemetenteNfEntradaFiliEmit);}
     public void selecionaRemetenteNfEntradaFiliEmit(){
        waitForInvisibilityOfElementLocated(loadingWait);
        click(selecionaRemetenteNfEntradaFiliEmit);}

    //efetuarLancamentoNotaEntradaSemChaveComplemento
    public void selecionaOperacaoComplemento(){
        click(selecionaTpOperacComplemento);}
    public void clicaAbaDadosAdicionaisEntrada(){
        click(clicarAbaDadosAdicionaisEntrada);
    }
    public void clicaAdicionarDadosAdicionaisEntrada(){
        click(clicarAdicionarDadosAdicionaisEntrada);
    }
    public void clicaMensagemDadosAdicionaisEntrada(){
        click(clicaMensagemDadosAdicionaisEntrada);}

   //validarLancamentoNotaEntradaComChaveFilialControlaEstoqueENaoControlaLoteNãoSugereAlmoxarifado
    public void clicarAcoesEntrada(){click(clicarAcoesEntrada);}
    public void clicarFecharNFAcoes(){click(clicarFecharNFAcoes);}
    public void clicarEmCancelarEntrada(){click(clicarEmCancelarEntrada);}



    public void uploadImportacao(){
        click(clickUploadImportacao);
    }
    public void escolherArquivo() {
        click(escolherArquivo);
        selecionarArquivo(escolherArquivo);
    }

}